﻿local addonName, PRIVATE = ...
local MBFunc = PRIVATE.Functions
MessageBoardXML.Editor.ID=nil;
MessageBoardXML.Editor.Goal=nil;
MessageBoardXML.Editor.Level=nil;
MessageBoardXML.Editor.Category=nil;
MessageBoardXML.Editor.CopyText=nil;
local Quotedmsg=nil;
local L = LibStub("AceLocale-3.0"):GetLocale("MessageBoard")
local MBDialog = LibStub("LibDialog-1.0")
local ren=DuckLibMB.Render;
local r,g,b = 1, 1, 1;

function MessageBoard_Editor_OnLoad(self)
	tinsert(UISpecialFrames,self);
end

function MessageBoardXML.Editor:Init(id,category,topic,msg,level,colorr,colorg,colorb)
	self.msg=msg;
	local message=msg.Text;
	self.Goal=msg.Time;
	Quotedmsg=message;
	self.Category=category;
	self.ID=id;
	if (not level) then level=0; end
	self.Level=level;
	if colorr then
		r=colorr
		g=colorg
		b=colorb
	end
	if (not topic) then MessageBoard_EditorTopicLabel:Hide(); MessageBoard_EditorTopicName:Hide(); MessageBoard_Editor_Announce:Hide(); MessageBoard_Editor_Sticky:Hide(); MessageBoard_Editor_Locked:Hide(); MessageBoard_Editor_Quote:Hide();
	else
		local catname
		catname=MessageBoardXML:Setting("Category"..category.."Value");
		MessageBoard_EditorTopicLabel:Show(); MessageBoard_EditorTopicName:Show();MessageBoard_EditorCategoryName:SetText(catname);
		MessageBoard_EditorTopicName:SetText(ren:toASCII(topic));MessageBoard_EditorTopicName:SetFocus();MessageBoard_EditorTopicError:SetText("");
		MessageBoard_EditorSaveDraft:Show();MessageBoard_EditorLoadDraft:Show();
		if (MessageBoardXML.Administrator or  MessageBoardXML.MyRank=="Moderator") then  -- only allow admins and moderators to set stickies, sticky locks, announcements, and locked posts
		MessageBoard_Editor_Announce:Show(); MessageBoard_Editor_Sticky:Show(); MessageBoard_Editor_Locked:Show(); MessageBoard_Editor_StickyLock:Show();
		else MessageBoard_Editor_Announce:Hide(); MessageBoard_Editor_Sticky:Hide(); MessageBoard_Editor_Locked:Hide();	MessageBoard_Editor_StickyLock:Hide(); end
		MessageBoardXML.Editor:AllowColorPicker()
	end
	if MessageBoard_LS.Quoted==true then MessageBoard_Editor_Quote:SetChecked(true); end
	if id==3 and MessageBoard_LS.Quoted==false then -- only if replying
		MessageBoard_Editor_Quote:SetChecked(false); message="" ;
	end
	
	if (not message) then message=""; end
	MessageBoard_EditorSBEdit:SetText(ren:toASCII(message));
	MessageBoard_EditorMBColorSwatch:SetColorTexture(r,g,b);
	MessageBoard_EditorMBDColorSwatch:SetColorTexture(MessageBoard_LS.colorR or 1,MessageBoard_LS.colorG or 1, MessageBoard_LS.colorB or 1);
	MessageBoard_Editor_Announce:SetChecked(false);
	MessageBoard_Editor_Sticky:SetChecked(false);
	MessageBoard_Editor_Locked:SetChecked(false);
	MessageBoard_Editor_StickyLock:SetChecked(false);
	if id==6 then
		MessageBoard_EditorCategoryLabel:SetText(L["EDITOR_PM_LABEL"])
		MessageBoard_EditorTopicLabel:SetText(L["EDITOR_PMTO_LABEL"]..tostring(category));
	else
		MessageBoard_EditorCategoryLabel:SetText(L["EDITOR_CAT_LABEL"])
		MessageBoard_EditorTopicLabel:SetText(L["EDITOR_TOPIC_LABEL"])
	end
	MessageBoard_EditorMessageLabel:SetText(L["EDITOR_MESSAGE_LABEL"])
	MessageBoard_EditorSave:SetText(L["EDITOR_MESSAGE_SAVE"])
	MessageBoard_EditorSaveDraft:SetText(L["EDITOR_MESSAGE_SAVEDRAFT"])
	MessageBoard_EditorLoadDraft:SetText(L["EDITOR_MESSAGE_LOADDRAFT"])
	MessageBoard_EditorCopyAll:SetText(L["EDITOR_MESSAGE_COPY"])
	MessageBoard_EditorDiscard:SetText(L["EDITOR_MESSAGE_DISCARD"])
	MessageBoard_Editor_AnnounceText:SetText(L["EDITOR_MESSAGE_ANNOUNCE"])
	MessageBoard_Editor_StickyText:SetText(L["EDITOR_MESSAGE_STICKY"])
	MessageBoard_Editor_StickyLockText:SetText(L["EDITOR_MESSAGE_STICKYLOCK"])
	MessageBoard_Editor_LockedText:SetText(L["EDITOR_MESSAGE_LOCKED"])
	MessageBoard_Editor_QuoteText:SetText(L["EDITOR_MESSAGE_QUOTE"])
	MessageBoard_PollEditorPollQLabel:SetText(L["EDITOR_POLL_QUESTION"])
	MessageBoard_PollEditorPollALabel:SetText(L["EDITOR_POLL_ANSWERS"])
	MessageBoard_PollEditorReset:SetText(L["EDITOR_POLL_RESET"])
	MBDColorPickerFrame_SavedColor:SetText(L["EDITOR_COLORPICKER_SAVED"])
	MBColorPickerFrame_SelectedColor:SetText(L["EDITOR_COLORPICKER_SELECTED"])
	MBDColorPickerOkayButton:SetText(L["EDITOR_COLORPICKER_USE"])
	MBColorPickerOkayButton:SetText(L["EDITOR_COLORPICKER_USE"])
	MBDColorPickerCancelButton:SetText(L["EDITOR_COLORPICKER_CANCEL"])
	MBColorPickerCancelButton:SetText(L["EDITOR_COLORPICKER_CANCEL"])
	MessageBoard_EditorMBColorLabel:SetText(L["EDITOR_COLORPICKER_SELECTED"])
	MessageBoard_EditorMBDColorLabel:SetText(L["EDITOR_COLORPICKER_SAVED"])
	
	
	
	local i
	for i=1,12 do
		_G["MessageBoard_PollAnswersScrollerAnswer"..i.."Title"]:SetText(L["EDITOR_POLL_ANSWER"]..i..":")
	end
	if (self.Level==30) then MessageBoard_Editor_Locked:SetChecked(true);
	elseif (self.Level==20) then MessageBoard_Editor_Announce:SetChecked(true);
	elseif (self.Level==15) then MessageBoard_Editor_StickyLock:SetChecked(true);
	elseif (self.Level==10) then MessageBoard_Editor_Sticky:SetChecked(true);
	end
	MessageBoard_EditorSBEdit:SetCursorPosition(0);
	MessageBoard_EditorTopicName:SetCursorPosition(0);

	if self.ID==MessageBoardXML.Editor.ID_NEWPOLL then
		MessageBoard_Editor:Show();	MessageBoard_PollEditor:Show();
	elseif self.ID==MessageBoardXML.Editor.ID_EDITMESSAGE then -- editing
		MessageBoardXML.Editor:AllowColorPicker()
		MessageBoard_Editor:Show();	MessageBoard_PollEditor:Hide();
	    if self.msg.Poll then
			 MessageBoard_EditorTopicName:Hide(); MessageBoard_Editor_Announce:Hide(); MessageBoard_Editor_Sticky:Hide(); MessageBoard_Editor_StickyLock:Hide(); MessageBoard_Editor_Locked:Hide(); MessageBoard_Editor_Quote:Hide();
		end
	else MessageBoard_Editor:Show(); MessageBoard_PollEditor:Hide();
	end
end

function MessageBoardXML.Editor:CheckClick(self)
	if (self==MessageBoard_Editor_Announce) then
		MessageBoard_Editor_Sticky:SetChecked(false)
		MessageBoard_Editor_Locked:SetChecked(false)
		MessageBoard_Editor_StickyLock:SetChecked(false)
	end
	if (self==MessageBoard_Editor_Sticky) then
		MessageBoard_Editor_Announce:SetChecked(false)
		MessageBoard_Editor_Locked:SetChecked(false)
		MessageBoard_Editor_StickyLock:SetChecked(false)
	end
	if (self==MessageBoard_Editor_StickyLock) then
		MessageBoard_Editor_Announce:SetChecked(false)
		MessageBoard_Editor_Locked:SetChecked(false)
		MessageBoard_Editor_Sticky:SetChecked(false)
	end
	if (self==MessageBoard_Editor_Locked) then
		MessageBoard_Editor_Announce:SetChecked(false)
		MessageBoard_Editor_Sticky:SetChecked(false)
		MessageBoard_Editor_StickyLock:SetChecked(false)
	end
	if MessageBoardXML.Editor.ID==3 then -- editing
		MessageBoardXML.Editor:AllowColorPicker()
		if (MessageBoard_Editor_Quote:GetChecked()) then
			local mycurrenttext=nil;
			local newmsg=nil;
			mycurrenttext=MessageBoard_EditorSBEdit:GetText();
			newmsg=ren:toASCII(mycurrenttext..Quotedmsg);
			MessageBoard_EditorSBEdit:SetText(newmsg); MessageBoard_EditorSBEdit:SetCursorPosition(0);
		else
			local mycurrenttext=nil;
			local newmsg="";
			MessageBoard_EditorSBEdit:SetText(newmsg); MessageBoard_EditorSBEdit:SetCursorPosition(0);
		end
	end
end

function MessageBoardXML.Editor:GetItemLink(itemID)
	if (not itemID) then return nil; end
	local itemName,itemLink,itemRarity,itemLevel,itemMinLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,itemTexture=GetItemInfo(itemID);
	return itemLink;
end

function MessageBoardXML.Editor:ItemDrop(editor)
	local item,itemID,link=GetCursorInfo();
	ClearCursor();
	if (not link) then return; end
	if (editor) then
		MessageBoard_EditorSBEdit:Insert(self:GetItemLink(link));
		return;
	end
end

function MessageBoardXML.Editor:CopyAll()
	MessageBoardXML.Editor.CopyText=MessageBoard_EditorSBEdit:GetText();
	MBDialog:Register("MessageBoardTextEditorCopyDialog", {
	  text = L["POPUP_TEXT_COPY"],
	  buttons = {
		{
		  text = "Close",
		},
	  },
	  editboxes = {
		{
		  auto_focus = true,
		  width=200,
		},
	  },
	  on_show = function(self, data)
		self.text:SetFormattedText("\n"..L["POPUP_TEXT_COPY"].."\n")
		self.editboxes[1]:SetText(MessageBoardXML.Editor.CopyText)
		self.editboxes[1]:HighlightText()
	  end,
	  hide_on_escape = true,
	  show_while_dead = true,
	})
	MBDialog:Spawn("MessageBoardTextEditorCopyDialog")
end

function MessageBoardXML.Editor:SaveDraft()
	MessageBoard_LS.Draft = MessageBoard_EditorSBEdit:GetText();
	MessageBoard_LS.DraftTitle = MessageBoard_EditorTopicName:GetText()
	MessageBoard_EditorTopicError:SetText("|cFFFFFFFF"..L["EDITOR_DRAFT_SAVED"]);
end

function MessageBoardXML.Editor:LoadDraft()
	if MessageBoard_LS.Draft then
		MessageBoard_EditorSBEdit:SetText(MessageBoard_LS.Draft);
		MessageBoard_EditorTopicName:SetText(MessageBoard_LS.DraftTitle);
		MessageBoard_EditorTopicError:SetText("|cFFFFFFFF"..L["EDITOR_DRAFT_LOADED"]);
	end
end

function MessageBoardXML.Editor:Save()
	local topic=ren:toHTML(MessageBoard_EditorTopicName:GetText());
	if strfind(topic,"/") then MessageBoard_EditorTopicError:SetText("|cFFFF0000No forward slashes."); return; end
	if (MessageBoard_Editor_Locked:GetChecked()) then self.Level=30;
	elseif (MessageBoard_Editor_Announce:GetChecked()) then self.Level=20;
	elseif (MessageBoard_Editor_StickyLock:GetChecked()) then self.Level=15;
	elseif (MessageBoard_Editor_Sticky:GetChecked()) then self.Level=10;
	elseif (self.ID==MessageBoardXML.Editor.ID_NEWPOLL) then self.Level=40;
	elseif (self.Level==40) then self.Level=40;
	else self.Level=0; end

	if (type(self.ID)=="function") then
		self.ID(self,self.Category,topic,ren:toHTML(MessageBoard_EditorSBEdit:GetText()),self.Goal,self.Level);
	else
		if self.ID==MessageBoardXML.Editor.ID_NEWTOPIC then -- new topic
			self.msg.Poll=nil;
			if (not topic or MBFunc.isBlank(topic)) then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_MISSING_NAME"]); return; end
			if (dbPath["//MBPR/Base/"..self.Category.."/"..topic]) then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_TOPIC_EXISTS"]); return; end
		elseif self.ID==MessageBoardXML.Editor.ID_NEWMESSAGE then -- new message/reply
			self.msg.Poll=nil;			
		elseif self.ID==MessageBoardXML.Editor.ID_NEWPOLL then -- new poll
			local index;
			self.msg.Poll={};
			for index=1,12 do local txt=strtrim(_G["MessageBoard_PollAnswersScrollerAnswer"..index]:GetText()) or ""; if (txt~="") then table.insert(self.msg.Poll,ren:toHTML((txt))); end end
			self.msg.Poll.Question=ren:toHTML((strtrim(tostring(MessageBoard_PollEditorPollName:GetText()))) or "");
			if (MBFunc.isBlank(self.msg.Poll.Question)) then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_MISSING_POLLQ"]); return; end
			if (MBFunc.isBlank(self.msg.Poll[1])) then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_MISSING_POLLA"]); return; end
			if MBFunc.isBlank(topic or "") then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_MISSING_NAME"]); return; end
			if (dbPath["//MBPR/Base/"..self.Category.."/"..topic]) then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_TOPIC_EXISTS"]); return; end
		elseif self.ID==MessageBoardXML.Editor.ID_EDITMESSAGE then -- edited text
			if self.msg.Poll then self.Level=40; end			
		end
		self.msg.Text=ren:toHTML(MessageBoard_EditorSBEdit:GetText());
		self.colorR = r
		self.colorG = g
		self.colorB = b
		MessageBoardXML:EditedText(self.ID,self.Category,topic,self.msg,self.Level,self.colorR,self.colorG,self.colorB);
	end
	MessageBoard_Editor:Hide();
	MBColorPickerFrame:Hide();
	MBDColorPickerFrame:Hide();
	if MBWhere=="ViewTopics" then MessageBoardXML:ViewTopics(); end
end

function MessageBoardXML.Editor:Discard()
	MessageBoard_Editor:Hide();
	MBColorPickerFrame:Hide();
	MBDColorPickerFrame:Hide();
	if MBWhere=="ViewTopics" then MessageBoardXML:ViewTopics(); end
end

function MessageBoardXML.Editor:ResetPoll()
	MessageBoard_PollEditorPollName:SetText("");
	local i=1;
	for i=1,12 do
	_G["MessageBoard_PollAnswersScrollerAnswer"..i]:SetText("");
	end
end

function MessageBoard_Editor_OnCursorChanged(self, x, y, width, height)
	local s_height = MessageBoard_EditorSB:GetHeight()
	local s_top    = MessageBoard_EditorSB:GetVerticalScroll()
	local s_bottom = s_top + s_height
	local cursor_y = -y
	local fudge = 11 -- allows for line height, padding and a little extra
	if cursor_y < s_top then
		MessageBoard_EditorSB:SetVerticalScroll(cursor_y)
	elseif cursor_y + fudge > s_bottom then
		MessageBoard_EditorSB:SetVerticalScroll(cursor_y + fudge - s_height)
	end
end

function MessageBoardXML.Editor:ShowEmoticons(self)
	local menu=DMMenuCreate(self)
	menu.Settings.Texture.Highlight="Interface\\FriendsFrame\\UI-FriendsFrame-HighlightBar-Blue"
	menu.Settings.Colour.Highlight={r=1,g=1,b=1}
	menu.Settings.Size=16
	menu.Settings.bd.insets={left=2,right=2,top=2,bottom=2,}
	menu.Settings.bd.edgeSize=2
	menu:Header(L["EDITOR_SELECT_ICON"])
    menu:Separator()
	local submenu1 = menu:Submenu(L["EDITOR_SELECT_SMILIES"].." 1")
	local submenu2 = menu:Submenu(L["EDITOR_SELECT_SMILIES"].." 2")
	local submenu3 = menu:Submenu(L["EDITOR_SELECT_MISC"])
	local submenu4 = menu:Submenu(L["EDITOR_SELECT_RAID"])
	menu.Timer=0.2    -- value in seconds
	local temp={}
	local i = 1
		temp[i]="amazed"
		temp[i+1]="angel"
		temp[i+2]="angry"
		temp[i+3]="angryavian"
		temp[i+4]="annoyed"
		temp[i+5]="astonished"
		temp[i+6]="bandit"
		temp[i+7]="blushing"
		temp[i+8]="blushingcute"
		temp[i+9]="bruisedeye"
		temp[i+10]="clown"
		temp[i+11]="content"
		temp[i+12]="cool"
		temp[i+13]="coollaugh"
		temp[i+14]="crying"
		temp[i+15]="cute"
		temp[i+16]="cutecatface"
		temp[i+17]="cyclops"
		temp[i+18]="dead"
		temp[i+19]="devil"
		temp[i+20]="doh"
		temp[i+21]="dohsilent"
		temp[i+22]="doubtful"
		temp[i+23]="dragonmonk"
		temp[i+24]="evilsmile"
		temp[i+25]="geeky"
		temp[i+26]="geekydoubtful"
		temp[i+27]="hungrypinkball"
		temp[i+28]="indifferent"
		temp[i+29]="inlove"
		temp[i+30]="kissing"
		temp[i+31]="kissinglovingly"
		temp[i+32]="laugh"
		temp[i+33]="lol"
		temp[i+34]="lolnaughty"
		temp[i+35]="mustache"
		temp[i+36]="naughtysmile"
		temp[i+37]="neighbourlycreature"
		temp[i+38]="ninja"
		temp[i+39]="nuuu"
		temp[i+40]="nuuulaughing"
		temp[i+41]="nuuushouting"
		temp[i+42]="protesting"
		temp[i+43]="robot"
		temp[i+44]="sad"
		temp[i+45]="shifty"
		temp[i+46]="shiftywhistling"
		temp[i+47]="shocked"
		temp[i+48]="sick"
		temp[i+49]="silent"
		temp[i+50]="silentcompletely"
		temp[i+51]="sillyteeth"
		temp[i+52]="sillyteethnaughty"
		temp[i+53]="skeptical"
		temp[i+54]="skull"
		temp[i+55]="sleep"
		temp[i+56]="smile"
		temp[i+57]="sweating"
		temp[i+58]="tongue"
		temp[i+59]="tonguewink"
		temp[i+60]="totallyshocked"
		temp[i+61]="uneasy"
		temp[i+62]="vampire"
		temp[i+63]="veryangry"
		temp[i+64]="verycontent"
		temp[i+65]="verysad"
		temp[i+66]="weeping"
		temp[i+67]="winklaugh"
		temp[i+68]="winksmile"
		temp[i+69]="yawn"
	for i=1,35 do
		submenu1:Button(temp[i],function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\"..temp[i]) end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\"..temp[i])
	end
		for i=36,70 do
		submenu2:Button(temp[i],function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\"..temp[i]) end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\"..temp[i])
	end
	submenu3:Button("Exclamation Mark",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\yellowexclamation") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\yellowexclamation")
	submenu3:Button("Checkmark",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\checked") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\checked")
	submenu3:Button("Grave Stone",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\gravestone") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\gravestone")
	submenu3:Button("Horde",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\horde") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\horde")
	submenu3:Button("Alliance",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\alliance") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\alliance")
	submenu3:Button("Hearthstone",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\hearthstone") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\hearthstone")
	submenu3:Button("Question Mark",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\questionmark") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\questionmark")
	submenu3:Button("Bag",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\bag") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\bag")
	submenu3:Button("Portal",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\portal") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\portal")
	submenu3:Button("Heroic Skull",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\heroicskull") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\heroicskull")
	submenu4:Button("Square",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\square") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\square")
	submenu4:Button("Cross",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\cross") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\cross")
	submenu4:Button("Moon",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\moon") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\moon")
	submenu4:Button("Skull",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\skull2") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\skull2")
	submenu4:Button("Triangle",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\triangle") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\triangle")
	submenu4:Button("Diamond",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\diamond") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\diamond")
	submenu4:Button("Circle",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\circle") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\circle")
	submenu4:Button("Star",function () MessageBoardXML.Editor:InsertEmoticon(self,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\star") end,nil,nil,nil,"Interface\\AddOns\\MessageBoard\\Images\\Icons\\star")
	menu:Show()
end

function MessageBoardXML.Editor:InsertEmoticon(self,icon)
	--MessageBoard_EditorSBEdit:Insert(" |T"..icon..":0:0:0:0|t ")
	MessageBoard_EditorSBEdit:Insert(" |T"..icon..":0|t ")
end

local mbcp_func, mbcp_opacityfunc, mbcp_cancelfunc

function MessageBoardXML.Editor:MBShowColorPicker()
	MBColorPickerFrame:ClearAllPoints();
	MBColorPickerFrame:SetPoint("RIGHT", "MessageBoard_Editor", "LEFT",0,0);
	MBColorPickerFrame:SetColorRGB(r,g,b);
	MBColorPickerFrame.hasOpacity = nil
	MBColorPickerFrame.previousValues = {r,g,b};
	MBColorPickerFrame.func, MBColorPickerFrame.opacityFunc, MBColorPickerFrame.cancelFunc =  mbcp_func, mbcp_opacityfunc, mbcp_cancelfunc;
	MBColorPickerFrame:Hide();
	MBColorPickerFrame:Show();
end

function mbcp_func()
	local newR, newG, newB = MBColorPickerFrame:GetColorRGB();
	MessageBoard_EditorMBColorSwatch:SetColorTexture(newR,newG,newB)
end 

function mbcp_opacityfunc()
	local newR, newG, newB = MBColorPickerFrame:GetColorRGB();
	MessageBoard_EditorMBColorSwatch:SetColorTexture(newR,newG,newB)
	r=newR
	g=newG
	b=newB
end 

function mbcp_cancelfunc()
	local newR, newG, newB, newA = unpack(MBColorPickerFrame.previousValues)
	r=newR
	g=newG
	b=newB
	MessageBoard_EditorMBColorSwatch:SetColorTexture(newR,newG,newB)
end

local mbdcp_func, mbdcp_opacityfunc, mbdcp_cancelfunc

function MessageBoardXML.Editor:MBDShowColorPicker()
	MBDColorPickerFrame:ClearAllPoints();
	MBDColorPickerFrame:SetPoint("RIGHT", "MessageBoard_Editor", "LEFT",0,0);
	MBDColorPickerFrame:SetColorRGB(MessageBoard_LS.colorR or 1,MessageBoard_LS.colorG or 1,MessageBoard_LS.colorB or 1);
	MBDColorPickerFrame.hasOpacity = nil
	MBDColorPickerFrame.previousValues = {MessageBoard_LS.colorR or 1,MessageBoard_LS.colorG or 1,MessageBoard_LS.colorB or 1};
	MBDColorPickerFrame.func, MBDColorPickerFrame.opacityFunc, MBDColorPickerFrame.cancelFunc =  mbdcp_func, mbdcp_opacityfunc, mbdcp_cancelfunc;
	MBDColorPickerFrame:Hide();
	MBDColorPickerFrame:Show();
end

function mbdcp_func()
	local newR, newG, newB = MBDColorPickerFrame:GetColorRGB();
	MessageBoard_EditorMBDColorSwatch:SetColorTexture(newR,newG,newB)
end 

function mbdcp_opacityfunc()
	local newR, newG, newB = MBDColorPickerFrame:GetColorRGB();
	MessageBoard_EditorMBDColorSwatch:SetColorTexture(newR,newG,newB)
	MessageBoard_EditorMBColorSwatch:SetColorTexture(newR,newG,newB)
	MessageBoard_LS.colorR=newR
	MessageBoard_LS.colorG=newG
	MessageBoard_LS.colorB=newB
	r=newR
	g=newG
	b=newB
end 

function mbdcp_cancelfunc()
	local newR, newG, newB, newA = unpack(MBDColorPickerFrame.previousValues)
	MessageBoard_LS.colorR=newR
	MessageBoard_LS.colorG=newG
	MessageBoard_LS.colorB=newB
	r=newR
	g=newG
	b=newB
	MessageBoard_EditorMBDColorSwatch:SetColorTexture(newR,newG,newB)
end

function MessageBoardXML.Editor:AllowColorPicker()
	if MessageBoardXML:Setting("AllowColorPicker") then
		MessageBoard_EditorMBColor:Show()
		MessageBoard_EditorMBDColor:Show()
		MessageBoard_EditorMBColorLabel:Show()
		MessageBoard_EditorMBDColorLabel:Show()
	else
		MessageBoard_EditorMBColor:Hide()
		MessageBoard_EditorMBDColor:Hide()
		MessageBoard_EditorMBColorLabel:Hide()
		MessageBoard_EditorMBDColorLabel:Hide()
	end
end


-- Hook the container buttons
local containerFunc = function(button)
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			MessageBoard_EditorSBEdit:Insert(GetContainerItemLink(button:GetParent():GetID(), button:GetID()))
		end
	end
end
hooksecurefunc("ContainerFrameItemButton_OnModifiedClick", containerFunc)

local bankFunc = function(...)
	local args = {...}
	local self = args[1]
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			local id = self:GetID()
			local link = GetContainerItemLink(BANK_CONTAINER, id)
			MessageBoard_EditorSBEdit:Insert(link)
		end
	end
end
hooksecurefunc("BankFrameItemButtonGeneric_OnModifiedClick", bankFunc)

local inboxFunc = function(...)
	local args = {...}
	local self = args[1]
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			local id = self:GetID()
			local link = GetInboxItemLink(InboxFrame.openMailID, id)
			MessageBoard_EditorSBEdit:Insert(link)
		end
	end
end
hooksecurefunc("InboxFrame_OnModifiedClick", inboxFunc)

local dollFunc = function(...)
	local args = {...}
	local self = args[1]
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			local id = self:GetID()
			local link = GetInventoryItemLink("player", id)
			MessageBoard_EditorSBEdit:Insert(link)
		end
	end
end
hooksecurefunc("PaperDollItemSlotButton_OnModifiedClick", dollFunc)

local merchantFunc = function(...)
	local args = {...}
	local self = args[1]
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			local id = self:GetID()
			local link = GetMerchantItemLink(id)
			MessageBoard_EditorSBEdit:Insert(link)
		end
	end
end
hooksecurefunc("MerchantItemButton_OnModifiedClick", merchantFunc)

local linkFunc = function(...)
	local args = {...}
	local self = args[1]
	local linktext = args[3]
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			MessageBoard_EditorSBEdit:Insert(linktext)
		end
	end
end
hooksecurefunc("ChatFrame_OnHyperlinkShow", linkFunc)

local spellFunc = function(self, button)
	if IsShiftKeyDown() then
		local offset
		local page
		if SpellBookFrame.bookType == BOOKTYPE_PET then
			offset = 0
			page = SPELLBOOK_PAGENUMBERS[BOOKTYPE_PET]
		else
			offset = SpellBookFrame.selectedSkillLineOffset
			page = SPELLBOOK_PAGENUMBERS[SpellBookFrame.selectedSkillLine]
		end
		local sid = self:GetID() + offset + (SPELLS_PER_PAGE*(page - 1))
		if MessageBoard_EditorSBEdit:HasFocus() then
			MessageBoard_EditorSBEdit:Insert(GetSpellLink(sid, SpellBookFrame.bookType))
		end
	end
end
hooksecurefunc("SpellButton_OnModifiedClick", spellFunc)